//  Bezrodnykh I.P.    Visual C++ 
//    
bool  Terrain(char* pFileName, C3dShape*  pTerrain, C3dScene *pScene)
{
//============================================================
//   (mesh)   -  

//    ,     
   D3DVECTOR vlist[] = 	{
							 {-1.0,  -6.0,  -1.0},
							 { 1.0,  -6.0,  -1.0},
							 { 1.0,  -6.0,   1.0},
							 {-1.0,  -6.0,   1.0}
						};


    //     
	int iVectors = sizeof(vlist) / sizeof(D3DVECTOR);


//      ,
//  : , 1, 2,  ..
	int iFaces [] = {4, 0, 3, 2, 1, //  
		             4, 0, 1, 2, 3, //   
					            0 };//    
 
         
 
 
//          
    //  pTerrain = new C3dShape;
      pTerrain->Create(vlist, iVectors, iFaces);

       

    //  
      C3dTexture* pTex = new C3dTexture;
	 
	  int h=pTex->Load(pFileName); if(h==0) return false;

      pScene->m_ImgList.Append(pTex);

	  //     
      pTerrain->SetFaceTexture(0,pTex);
	  

      //  
	  //    2x2 
      //      ,  
	  //      .  , 
	  //   ,    
	  // 
      //
	  C3dWrap wrap;
	  wrap.Create(D3DRMWRAP_FLAT,NULL,
		          -1,   0, -1, //   
				   0,  -1,  0, //   
				   0,   0,  1, // epx 
                   0,   0,     //   
				   40,  -40);//   ( );


	  //     
      wrap.Apply(pTerrain,0);

	  
   

//    
     C3dMatrix ms;
     ms.Scale(10000,1,10000);
     ms.Rotate(0,0,0 );
     ms.Translate( 0,0,0);
     pTerrain->AddTransform(ms, D3DRMCOMBINE_BEFORE);

	 return true;
}



//    
bool  Terrain(int IDB_BGROUND, C3dShape*  pTerrain, C3dScene *pScene)
{
//============================================================
//   (mesh)   -  

//    ,     
   D3DVECTOR vlist[] = 	{
							 {-1.0,  -6.0,  -1.0},
							 { 1.0,  -6.0,  -1.0},
							 { 1.0,  -6.0,   1.0},
							 {-1.0,  -6.0,   1.0}
						};


    //     
	int iVectors = sizeof(vlist) / sizeof(D3DVECTOR);


//      ,
//  : , 1, 2,  ..
	int iFaces [] = {4, 0, 3, 2, 1, //  
		             4, 0, 1, 2, 3, //   
					            0 };//    
 
         
 
 
//          
    //  pTerrain = new C3dShape;
      pTerrain->Create(vlist, iVectors, iFaces);

       

    //  
      C3dTexture* pTex = new C3dTexture;
	 
	  int h=pTex->Load(IDB_BGROUND); if(h==0) return false;

      pScene->m_ImgList.Append(pTex);

	  //     
      pTerrain->SetFaceTexture(0,pTex);
	  

      //  
	  //    2x2 
      //      ,  
	  //      .  , 
	  //   ,    
	  // 
      //
	  C3dWrap wrap;
	  wrap.Create(D3DRMWRAP_FLAT,NULL,
		          -1,   0, -1, //   
				   0,  -1,  0, //   
				   0,   0,  1, // epx 
                   0,   0,     //   
				   40,  -40);//   ( );


	  //     
      wrap.Apply(pTerrain,0);

	  
   

//    
     C3dMatrix ms;
     ms.Scale(10000,1,10000);
     ms.Rotate(0,0,0 );
     ms.Translate( 0,0,0);
     pTerrain->AddTransform(ms, D3DRMCOMBINE_BEFORE);

	 return true;
}

