//	:	        d.cpp
//  Bezrodnykh I.P. "  (Visual C++ & DirectX)"
//	:   3dPlus,   
//   3-
//  :   
//     (   )
//       
//     

//       :
//  1)  
//  2)  
//  3) 
//  4)  
//  5)  
//  6)  
//  7)    
//  8)    
//  9)  
// 10)   
// 11)   ()
// 12)  
// 13)   - 
// 14) DirectX
// 15) 
// 16)    
// 17) 
// 18)       
// 19)     
// 20)    

//-----------------------------------------------------------------------------------
//   
#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions
#include "mmsystem.h"      
#include "d3drm.h"
#include "d3drmwin.h"
#include "3dPlus.h"
#include "common/Terrain.h"
#include "common/Hous.h"
#include "common/Clone.h"
#include "common/Camera.h"

#include "resource.h"

//  
#pragma comment (lib, "3dPlusD_01.lib")
#pragma comment (lib, "d3drm.lib")
#pragma comment (lib, "ddraw.lib")
#pragma comment (lib, "winmm.lib")


//    Use MFC ...  Project\Settings
//     Tools\Options\Directories  
//   3dPlus\SDK\INC ,  3dPlus\SDK\LIB  
//   3dPlus\INCLUDE ,  3dPlus\LIB


 //   
   C3dScene*  pScene   = NULL; //     
   C3dShape*  pTerrain = NULL; //     terrain 
   C3dShape*  pT04     = NULL; //     
   C3dShape*  pHous    = NULL;
   C3dShape*  pPlaner  = NULL;
   C3dShape*  pShape   = NULL;
   CCamera*   pCamera1 = NULL; 
   CCamera*   pCamera2 = NULL; 
   CCamera*   pCamera3 = NULL; 


   DWORD g_start_time=0; //    
   int   flagSound=0;    //  
   int   HelpText   =-1; // Help
   int   OldHelpText= 0;
 
 
//     
#define KEY_DOWN(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)
#define KEY_UP(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 0 : 1)


//   
int wscreen=GetSystemMetrics(SM_CXSCREEN);
int hscreen=GetSystemMetrics(SM_CYSCREEN);



//   CApp   
//    CWinApp
   class  CApp : public CWinApp
   {
    public:	 
      virtual BOOL InitInstance();        //  
	  virtual BOOL OnIdle(LONG ICount);   //  
	  void  InputKey();                   //    
                        
      C3dVector m_vPos;                   //   
      C3dVector m_vDir;                   //    

	  C3dVector m_vCameraPos;             //  
      C3dVector m_vCameraDir;             //  
      double dCamera;                     //     


   };

  class  CWndEx : public C3dWnd 
   {
  public:
      virtual	  void TextOut(void);//   
      virtual	  void Clear(void);


  };

//    
void  CWndEx::Clear()
{
 
 CBrush brush1;
 brush1.CreateSolidBrush(RGB( 205,205,255));

//==========================================================
 CDDSurface* pBB = m_pDD->GetBackBuffer();
 CDC* pDC = pBB->GetDC();
 pDC->SelectObject(&brush1);
//   
 pDC->PatBlt(0,0,360,40,PATCOPY);      //////////////////////
 pBB->ReleaseDC(pDC);
//=========================================================== 


}
//    
void  CWndEx::TextOut()
{
 
 CBrush brush1,brush2;
 brush1.CreateSolidBrush(RGB( 190,190,255));
 brush2.CreateSolidBrush(RGB( 205,205,255));
	
 if(KEY_DOWN(VK_F1)){ HelpText= -HelpText; Sleep(200);}


//   
 CString str;
 CString str1=   "F1        - Help";

 CString str2=   "F2        - Set tank  ";
 CString str3=   "F3        - Set planer";
 CString str4=   "F4        - Set Camera";
 CString str5=   "Alt       - Move planer";
 CString str6=   "Arrow     - Rotate planer";
 CString str7=   "1         - Rotate left  planer ";
 CString str8=   "2         - Rotate right planer ";
 CString str9=   "Up Arrow     - Start  tank";
 CString str10=  "Down Arrow   - Revers tank";
 CString str11=  "Left Arrow   - Rotate left";
 CString str12=  "Right Arrow  - Rotate right";
 CString str13=  "SHIFT  - Stop  motors tank";
 CString str14=  "Esc    - exit";

//==========================================================
 CDDSurface* pBB = m_pDD->GetBackBuffer();
 CDC* pDC = pBB->GetDC();
 pDC->SelectObject(&brush2);

//   
 //pDC->PatBlt(0,0,220,40,PATCOPY);      //////////////////////

//===========================================================
 pDC->SetBkMode(TRANSPARENT);
 
 C3dVector pPos;
 if(pShape) pShape->GetPosition(pPos);
 str.Format("x= %6.2f  y = %6.2f  z= %6.2f ",pPos.x, pPos.y, pPos.z);
 
 pDC->SetTextColor(RGB(255,255,0));
 pDC->TextOut(10,0,str1);
	
 pDC->SetTextColor(RGB(255,0,0));
 pDC->TextOut(10,20,str);
  
 if((HelpText==-1)&&(OldHelpText!=-1))
 {
  pDC->SelectObject(&brush2);
  //   
  pDC->PatBlt(0,0,200,250,PATCOPY);

 }

 if(HelpText==1)
 {
 pDC->SetTextColor(RGB(255,0,0));

 pDC->TextOut(10,40,str2);	
 pDC->TextOut(10,55,str3);	
 pDC->TextOut(10,70,str4);	
 pDC->TextOut(10,85,str5);	
 pDC->TextOut(10,100,str6);	
 pDC->TextOut(10,115,str7);	
 pDC->TextOut(10,130,str8);	
 pDC->TextOut(10,145,str9);	
 pDC->TextOut(10,160,str10);	
 pDC->TextOut(10,175,str11);	
 pDC->TextOut(10,190,str12);
 pDC->TextOut(10,205,str13);	
 pDC->TextOut(10,220,str14);	
 } 
	pBB->ReleaseDC(pDC);
	OldHelpText=HelpText;
	 
}



//    CWinApp
 BOOL CApp::InitInstance()
   {
 
//     C3dWnd
//      
    CWndEx *pWnd=new CWndEx;


//    
    pWnd->m_ColorModel = D3DCOLOR_RGB;

	
//    ( )
    pWnd->Create("3d programma",WS_POPUP | WS_VISIBLE,
    0,0,  wscreen,hscreen);


//     
	m_pMainWnd=pWnd;


//     
    pWnd->UpdateWindow();

    srand(GetTickCount()); //    



//   ,     
    pScene =new C3dScene;
    pScene->Create();

//    
    pScene->SetAmbientLight(0.4, 0.4, 0.4);

//       
    static C3dDirLight dl;
    dl.Create(0.8, 0.8, 0.8);
    pScene->AddChild(&dl);
    dl.SetPosition(-2, 2, -5);
    dl.SetDirection(1,-1,1);

//     
	pScene->SetBackground(0.8 ,0.8, 1);

//  
    pTerrain = new C3dShape;
    Terrain(IDB_BGROUND, pTerrain,pScene);
	pScene->AddChild(pTerrain);//   



//      (Mesh) 
    pT04 = new C3dShape;
  	pT04->Load(IDX_TANK);
	pScene->AddChild(pT04);//   

//      
 	C3dMatrix mt;
    mt.Scale(0.005,  0.005,  0.005);
    mt.Rotate(0,90,0 );
    pT04->AddTransform(mt, D3DRMCOMBINE_BEFORE);
    pT04->SetPosition(2500,  0,   50);
  


//================================================
//       (Mesh)
    pPlaner=new C3dShape;

  	pPlaner->Load("Models\\Planer.x");
	pScene->AddChild(pPlaner);
     

//    
	 C3dShape sh1;
     sh1.CreateSphere(0.1);
//      
	 pPlaner->AddChild( &sh1);	 
     sh1.SetPosition(0,-0.2,0);
	 
 
//  	 
    C3dShape Prop;
    Prop.Load("Models\\Prop.x");
   
    sh1.AddChild(&Prop);
    Prop.SetPosition( 0,0.128,0);
    sh1.SetRotation(0,0,1,2.3); 
 
//  ,   
    C3dMatrix m ;
    m.Translate(0 ,0, 0);
  	m.Rotate(0,0,0);
    if(pPlaner!=NULL) pPlaner->AddTransform(m, D3DRMCOMBINE_BEFORE);

   
//  ,   
	C3dMatrix mtp;
    mtp.Scale(10,  10,  10);
    mtp.Rotate(0,0,0 );
   if(pPlaner!=NULL) pPlaner->AddTransform(mtp, D3DRMCOMBINE_BEFORE);
   if(pPlaner!=NULL) pPlaner->SetPosition(2000,  2,   800);

//==========================================================
//      (Mesh)   
	C3dShape *pTree0 = new C3dShape;
  	pTree0->Load(IDX_PALMA);
	pScene->AddChild(pTree0);//   


//        
        C3dMatrix mtr1;
        mtr1.Scale(100,  100,  100);
        mtr1.Rotate(0,0,0 );
        mtr1.Translate( 0,0,0);
        pTree0->AddTransform(mtr1, D3DRMCOMBINE_BEFORE);
    
//    
	  pTree0->SetPosition(-300,  200,  -150);

	
// K  
        
       C3dVector vScaleP1=C3dVector(100,100,100);
       C3dVector vPositionP1=C3dVector(-300,  200,  150);
       CloneObject(pTree0,pScene,vScaleP1, vPositionP1);



//==========================================
     pHous = new C3dShape;
     CreateHous(IDB_G1,IDB_UP, pHous, pScene );

//    
    C3dMatrix ms1;
     ms1.Scale(100,400,50);
     ms1.Rotate(0,0,0 );
     ms1.Translate( 0,0, 0);
     pHous->AddTransform(ms1, D3DRMCOMBINE_BEFORE);

//     0-
	  pHous->SetPosition(0,  90,  300);

// K   1-
       C3dVector vScale1=C3dVector(100,400,50);
       C3dVector vPosition1=C3dVector(0,  90,  -300);
       CloneObject(pHous,pScene,vScale1, vPosition1);

// K   2-
       C3dVector vScale2=C3dVector(100,400,50);
       C3dVector vPosition2=C3dVector(300,  90,  300);
       CloneObject(pHous,pScene,vScale2, vPosition2);


// K   3-
       C3dVector vScale3=C3dVector(100,400,50);
       C3dVector vPosition3=C3dVector(300,  90,  -300);
       CloneObject(pHous,pScene,vScale3, vPosition3);


// K   4-
       C3dVector vScale4=C3dVector(100,400,50);
       C3dVector vPosition4=C3dVector(600,  90,  300);
       CloneObject(pHous,pScene,vScale4, vPosition4);


// K   5-
       C3dVector vScale5=C3dVector(100,400,50);
       C3dVector vPosition5=C3dVector(600,  90,  -300);
       CloneObject(pHous,pScene,vScale5, vPosition5);

// K   6-
       C3dVector vScale6=C3dVector(100,400,50);
       C3dVector vPosition6=C3dVector(900,  90,  300);
       CloneObject(pHous,pScene,vScale6, vPosition6);


// K   7-
       C3dVector vScale7=C3dVector(100,400,50);
       C3dVector vPosition7=C3dVector(900,  90,  -300);
       CloneObject(pHous,pScene,vScale7, vPosition7);

// K   8-
       C3dVector vScale8=C3dVector(100,400,50);
       C3dVector vPosition8=C3dVector(1200,  90,  300);
       CloneObject(pHous,pScene,vScale8, vPosition8);


// K   9-
       C3dVector vScale9=C3dVector(100,400,50);
       C3dVector vPosition9=C3dVector(1200,  90,  -300);
       CloneObject(pHous,pScene,vScale9, vPosition9);



	 // Add the shape to the scene
     //    
 	  pScene->AddChild(pHous);


//========================================================================

    C3dShape  runway1;// 
    runway1.CreateCuboid(1, 120, 5000);
    runway1.SetPosition(0, -6, 0);
    runway1.SetDirection(0,0,0, 0,0,1);
    runway1.SetColor(0.5, 0.5, 0.5);
    pScene->AddChild(&runway1);

    C3dShape  runway1_0; //  
    runway1_0.CreateCuboid(1, 2, 5000);
    runway1_0.SetPosition(0, -5, 0);
    runway1_0.SetDirection(0,0,0, 0,0,1);
    runway1_0.SetColor(1, 1, 1);
    runway1.AddChild(&runway1_0);


    C3dShape  runway2;// 
    runway2.CreateCuboid(1, 5000, 120);
    runway2.SetPosition(2000, -6, 0);
    runway2.SetDirection(0,0,0, 0,0,1);
    runway2.SetColor(0.5, 0.5, 0.5);
    pScene->AddChild(&runway2);


    C3dShape  runway3;// 
    runway3.CreateCuboid(1, 5000, 120);
    runway3.SetPosition(-2000, -6, 0);
    runway3.SetDirection(0,0,0, 0,0,1);
    runway3.SetColor(0.5, 0.5, 0.5);
    pScene->AddChild(&runway3);

//========================================================================
  
//     
	 pWnd->SetScene(pScene);
 
     ShowCursor(false);//  


/*    
//======================================================	 
	//   
	double rd = 0.5;
	C3dShape rz;
	rz.CreateRod(0, 0, -4000, 0, 0, 4000, rd);
	rz.SetColor(0,0,1);
	pScene->AddChild(&rz);

	C3dShape ry;
	ry.CreateRod(0, -4000, 0, 0, 4000, 0, rd);
    ry.SetColor(0,1,0);
	pScene->AddChild(&ry);

	C3dShape rx;
	rx.CreateRod(-4000, 0, 0, 4000, 0, 0, rd);
    rx.SetColor(1,0,0);
	pScene->AddChild(&rx);
//================================================================
*/

//   1,2,3
      pCamera1=new CCamera;
      pCamera1->Init(pScene);
 
      pCamera2=new CCamera;
      pCamera2->Init(pScene);

      pCamera3=new CCamera;
      pCamera3->m_vCamPos=C3dVector(-1000,800,0);
      pCamera3->m_vCamDir=C3dVector(1,0,0);
      pCamera3->m_vCamUp =C3dVector(0,1,0);
      pCamera3->Init(pScene);

  
      C3dVector vu=C3dVector(0,1,0); //   
	  pT04->GetDirection(m_vDir,vu); 
	  pT04->GetPosition(m_vPos);

//  1-   	 
      pCamera1->dCamera=24000;

 
      pCamera1->m_vCamPos=m_vPos +m_vDir * dCamera;
      pCamera1->m_vCamPos.y= m_vPos.y + 30 ; //  
      pCamera1->m_vCamDir=-(m_vDir);
      pCamera1->m_vCamUp=vu;

      pCamera1->SetCamera();
      pCamera1->SetCameraField(0.8);

	 return TRUE;

 }  //    InitInstance()




CApp App; //    CApp

int nCamera=1;

/////////////////////////////////////////////////////////////////////
//    double    
 double dz1=0, ay1=0 ;
 double az2=0, ay2=0 , ax2=0;
 double dz2=0, dy2=0 , dx2=0;

//           
void CApp::InputKey() 
{
if(KEY_DOWN(VK_ESCAPE)) PostQuitMessage(0); //   

  
 C3dVector vu=C3dVector(0,1,0); //  
 
 	if(KEY_DOWN(VK_F2))
	{
    pShape=pT04;
	nCamera=1; 
//    	 
    
	 pT04->GetDirection(m_vDir,vu); //  
	 pT04->GetPosition(m_vPos);//  

      pCamera1->m_vCamPos=m_vPos +m_vDir * pCamera1->dCamera;
      pCamera1->m_vCamPos.y= m_vPos.y + 30 ; //  
      pCamera1->m_vCamDir=-(m_vDir);
      pCamera1->SetCamera();
	
	}
	
	
	
	if(KEY_DOWN(VK_F3))
	{
     pShape=pPlaner;
	 nCamera=2;
//    
	  pCamera2->dCamera=20;
	  pPlaner->GetDirection(m_vDir,vu); //  
	  pPlaner->GetPosition(m_vPos);//  
     
      pCamera2->m_vCamPos=m_vPos -m_vDir * pCamera2->dCamera;
      pCamera2->m_vCamPos.y= m_vPos.y + 30 ; //  
      pCamera2->m_vCamDir=-(m_vDir);
      pCamera2->SetCamera();
	
	
	} 

     
if(nCamera==1)
{
  
	  pT04->GetDirection(m_vDir,vu); //  
	  pT04->GetPosition(m_vPos);//  

  
     if((dz1< 800)&& KEY_DOWN(VK_DOWN))    dz1 +=  21;  //  
     if((dz1>-800)&& KEY_DOWN(VK_UP) )     dz1 += -21; 

    
     if(KEY_DOWN(VK_LEFT))     ay1 += -0.25;      //  
     if(KEY_DOWN(VK_RIGHT))    ay1 +=  0.25;  




//===========================================================

//        
     C3dVector vct=-m_vDir;


      C3dVector vcs=pCamera1->m_vCamDir-vct; 
      vcs.x=vcs.x/40.0;
      vcs.y=vcs.y/40.0;
 	  vcs.z=vcs.z/40.0;
 
   

       vu=C3dVector(0,1,0);

      pCamera1->m_vCamDir =pCamera1->m_vCamDir -vcs;; 
   	  pCamera1->m_vCamPos=m_vPos - (pCamera1->m_vCamDir * pCamera1->dCamera);
      pCamera1->m_vCamPos.y= m_vPos.y + 30 ; //  
      pCamera1->SetCamera();

//=======================================================

      pShape=pT04;

}

//      
     C3dMatrix mt1;
  if(flagSound>1)
 { 
 
     mt1.Translate( 0,0,dz1);
     mt1.Rotate(0,ay1,0 );
     pT04->AddTransform(mt1, D3DRMCOMBINE_BEFORE);
     ay1 = ay1*0.9;  
 }



if(nCamera==2)
{
	  pPlaner->GetDirection(m_vDir,vu); //  
	  pPlaner->GetPosition(m_vPos);//  



     if(KEY_DOWN(49))    ay2  += -0.005; 
     if(KEY_DOWN(50) )   ay2  +=  0.005; 
     if(KEY_DOWN(32) )    m_vPos.y=2;
 
     if(KEY_DOWN(VK_DOWN))    ax2  +=  0.2; 
     if(KEY_DOWN(VK_UP) )     ax2  += -0.2; 
     
    
     if(KEY_DOWN(VK_LEFT))    az2  += -0.2; 
     if(KEY_DOWN(VK_RIGHT) )  az2  +=  0.2; 


 
//============================================================
//        
     C3dVector vct=-m_vDir;


      C3dVector vcs=pCamera2->m_vCamDir-vct; 
      vcs.x=vcs.x/40.0;
      vcs.y=vcs.y/40.0;
 	  vcs.z=vcs.z/40.0;
 
   

       vu=C3dVector(0,1,0);

      pCamera2->m_vCamDir =pCamera2->m_vCamDir -vcs;; 
   	  pCamera2->m_vCamPos=m_vPos - (pCamera2->m_vCamDir * pCamera2->dCamera);
      pCamera2->m_vCamPos.y= m_vPos.y + 10 ; //  
      pCamera2->SetCamera();

//===========================================================

}
  
 //  8  
     if(KEY_DOWN(56))         dz2 +=  0.005; 
     //  ALT  
     if(KEY_DOWN(18) )        dz2 += -0.005; 
 
//      
     C3dMatrix mt2;
      

     if((m_vPos.y>0)||(nCamera==1))
	 {  
		 mt2.Rotate(ax2,ay2,az2 );
		 mt2.Translate( dx2,dy2,dz2);
	 }
		 pPlaner->AddTransform(mt2, D3DRMCOMBINE_BEFORE);
	  

     if((m_vPos.y>2)&&(m_vPos.y<6))  dy2 -=0.01; 
	 if(m_vPos.y<=4.0) dz2 *=0.99;
     if(m_vPos.y<=2) dy2=0;

	 ax2 *=0.9;  az2 *=0.9; ay2 *=0.99;
 
//================================================================

	if(KEY_DOWN(VK_F4))
	{
       
      nCamera=3;
    
      pCamera3->SetCamera();
	}


    if(nCamera==3)
    {

        pCamera3->InputKey(); 
          
	}

//   
//============================================================
      if (( dz1 != 0)&& (flagSound==0)&&( nCamera==1))
		 { 
		  
	 //	 PlaySound("Sound\\enginesStart.wav", NULL, SND_FILENAME | SND_ASYNC | SND_LOOP) ;
	   PlaySound(MAKEINTRESOURCE(IDR_WAVE1), NULL, SND_RESOURCE| SND_ASYNC | SND_LOOP) ;
		   flagSound=1;
           g_start_time =GetTickCount();
 
		 } 
 
     if((flagSound==1)&&(GetTickCount()-g_start_time)>3000)
	 {
   
      PlaySound(NULL, NULL, NULL) ; // 
   // PlaySound("Sound\\engines.wav", NULL, SND_FILENAME | SND_ASYNC | SND_LOOP) ;
   PlaySound(MAKEINTRESOURCE(IDR_WAVE2), NULL, SND_RESOURCE| SND_ASYNC | SND_LOOP) ;
      flagSound=2; dz1=0.1;
	 }
     

//=============================================================
//  
if(KEY_DOWN(VK_SHIFT))
{
  dz1=0;
  PlaySound(NULL, NULL, NULL) ; // 
  flagSound=0;
}

//===============================================================
if(m_pMainWnd==NULL)return;
CWndEx *pWnd=(CWndEx*) m_pMainWnd;
pWnd->TextOut(); // 


}	 
///////////////////////////////////////////////////////////////////  

//   
BOOL CApp::OnIdle(LONG ICount)
{

    DWORD start_time   = GetTickCount(); //   
	BOOL bMore= CWinApp::OnIdle(ICount);
    
	if(m_pMainWnd)
	{
		

    InputKey(); //   
    

//        
//      
	C3dWnd *pWnd=(C3dWnd*) m_pMainWnd;
	if(pWnd->Update(1))  bMore=TRUE;

	}

	//  
    while((GetTickCount()-start_time)<30); //   0.03 . 
	 


	return bMore;
}







